Index: trunk/test/testrun_1b.sh
===================================================================
--- trunk/test/testrun_1b.sh	(revision 159)
+++ trunk/test/testrun_1b.sh	(revision 163)
@@ -20,5 +20,5 @@
 #
 
-MAXTEST=3; export MAXTEST
+MAXTEST=5; export MAXTEST
 LOGFILE="$PW_DIR/.samhain_log"; export LOGFILE
 RCFILE="$PW_DIR/testrc_1.dyn";  export RCFILE
@@ -229,7 +229,22 @@
 	    log_skip 2 $MAXTEST 'public PGP key 0x0F571F6C not present'
 	    log_skip 3 $MAXTEST 'public PGP key 0x0F571F6C not present'
+	    log_skip 4 $MAXTEST 'public PGP key 0x0F571F6C not present'
+	    log_skip 5 $MAXTEST 'public PGP key 0x0F571F6C not present'
 	else
 	    #
 	    # -------------  first test -------------
+	    #
+	    BUILDOPTS="--quiet $TRUST --enable-debug --with-gpg=${GPG} --enable-micro-stealth=137 --enable-login-watch --prefix=$PW_DIR --localstatedir=$PW_DIR --with-config-file=$RCFILE  --with-log-file=$PW_DIR/.samhain_log --with-pid-file=$PW_DIR/.samhain_lock --with-data-file=$PW_DIR/.samhain_file"
+	    testrun1b_internal "${BUILDOPTS}" 
+	    do_test_1b
+	    if [ $? -eq 0 ]; then
+		log_ok   1 $MAXTEST 'gpg signed config/database files'
+	    else
+		log_fail 1 $MAXTEST 'gpg signed config/database files'
+	    fi
+
+
+	    #
+	    # -------------  second test -------------
 	    #
 	    BUILDOPTS="--quiet $TRUST --enable-debug --with-gpg=${GPG} --with-checksum --enable-micro-stealth=137 --enable-login-watch --prefix=$PW_DIR --localstatedir=$PW_DIR --with-config-file=$RCFILE  --with-log-file=$PW_DIR/.samhain_log --with-pid-file=$PW_DIR/.samhain_lock --with-data-file=$PW_DIR/.samhain_file"
@@ -237,12 +252,25 @@
 	    do_test_1b
 	    if [ $? -eq 0 ]; then
-		log_ok   1 $MAXTEST 'gpg signed config/database files'
-	    else
-		log_fail 1 $MAXTEST 'gpg signed config/database files'
-	    fi
-
-
-	    #
-	    # -------------  second test -------------
+		log_ok   2 $MAXTEST 'gpg signed config/database files'
+	    else
+		log_fail 2 $MAXTEST 'gpg signed config/database files'
+	    fi
+
+
+	    #
+	    # -------------  third test -------------
+	    #
+	    BUILDOPTS="--quiet $TRUST --enable-debug --with-gpg=${GPG} --with-checksum --with-fp=EF6CEF54701A0AFDB86AF4C31AAD26C80F571F6C --enable-micro-stealth=137 --enable-login-watch --prefix=$PW_DIR --localstatedir=$PW_DIR --with-config-file=$RCFILE  --with-log-file=$PW_DIR/.samhain_log --with-pid-file=$PW_DIR/.samhain_lock --with-data-file=$PW_DIR/.samhain_file"
+	    testrun1b_internal "${BUILDOPTS}" 
+	    do_test_1b
+	    if [ $? -eq 0 ]; then
+		log_ok   3 $MAXTEST 'gpg signed config/database files'
+	    else
+		log_fail 3 $MAXTEST 'gpg signed config/database files'
+	    fi
+
+
+	    #
+	    # -------------  fourth test -------------
 	    #
 	    PRECONV=`find_path convert`
@@ -257,7 +285,7 @@
 		do_test_1b
 		if [ $? -eq 0 ]; then
-		    log_ok   2 $MAXTEST 'gpg signed config/database files'
+		    log_ok   4 $MAXTEST 'gpg signed config/database files'
 		else
-		    log_fail 2 $MAXTEST 'gpg signed config/database files'
+		    log_fail 4 $MAXTEST 'gpg signed config/database files'
 		fi
 	    fi
@@ -265,5 +293,5 @@
 
 	    #
-	    # -------------  third test -------------
+	    # -------------  fifth test -------------
 	    #
 	    if test -f /usr/local/lib/libprelude.so
@@ -275,7 +303,7 @@
 	    PM=`find_path prelude-manager`
 	    if [ -z "$PM" ]; then
-		log_skip 3 $MAXTEST 'prelude-manager not found in $PATH'
+		log_skip 5 $MAXTEST 'prelude-manager not found in $PATH'
 	    elif [ -z "$doall" ]; then
-		log_skip 3 $MAXTEST 'logging to prelude (or use --really-all)'
+		log_skip 5 $MAXTEST 'logging to prelude (or use --really-all)'
 	    else
 		BUILDOPTS="--quiet $TRUST --enable-debug --with-prelude --with-gpg=${GPG} --with-checksum --enable-micro-stealth=137 --enable-login-watch --prefix=$PW_DIR --localstatedir=$PW_DIR --with-config-file=$RCFILE  --with-log-file=$PW_DIR/.samhain_log --with-pid-file=$PW_DIR/.samhain_lock --with-data-file=$PW_DIR/.samhain_file"
@@ -283,7 +311,7 @@
 		do_test_1b_2
 		if [ $? -eq 0 ]; then
-		    log_ok   3 $MAXTEST 'logging to prelude'
+		    log_ok   5 $MAXTEST 'logging to prelude'
 		else
-		    log_fail 3 $MAXTEST 'logging to prelude'
+		    log_fail 5 $MAXTEST 'logging to prelude'
 		fi
 	    fi