Index: trunk/src/sh_getopt.c
===================================================================
--- trunk/src/sh_getopt.c	(revision 183)
+++ trunk/src/sh_getopt.c	(revision 210)
@@ -321,9 +321,9 @@
 #ifndef DEFAULT_CONSOLE
   if (num > 0) fputc ('\n', stdout);
-  printf (_(" console (/dev/console)")); ++num;
+  printf ("%s", _(" console (/dev/console)")); ++num;
 #else
   if (num > 0) fputc ('\n', stdout);
   if (0 == strcmp (DEFAULT_CONSOLE, _("NULL")))
-    { printf (_("console (/dev/console)"));  ++num; }
+    { printf ("%s", _("console (/dev/console)"));  ++num; }
   else
     { printf (_("console (%s)"), DEFAULT_CONSOLE);  ++num; }
@@ -406,8 +406,8 @@
 #if defined(USE_SYSTEM_MALLOC)
   if (num > 0) fputc ('\n', stdout);
-  printf (_(" using system malloc")); ++num;
+  fputs (_(" using system malloc"), stdout); ++num;
 #else
   if (num > 0) fputc ('\n', stdout);
-  printf (_(" using dnmalloc")); ++num;
+  fputs (_(" using dnmalloc"), stdout); ++num;
 #endif
 
@@ -554,6 +554,6 @@
 	     "(c) 1999-2008 Rainer Wichmann (http://la-samhna.de).\n"),
 	   VERSION);
-  fprintf (stdout, _("This software comes with ABSOLUTELY NO WARRANTY. "));
-  fprintf (stdout, _("Use at own risk.\n\n"));
+  fprintf (stdout, "%s",_("This software comes with ABSOLUTELY NO WARRANTY. "));
+  fprintf (stdout, "%s",_("Use at own risk.\n\n"));
 
   sh_getopt_print_log_facilities ();
@@ -567,56 +567,56 @@
 static int sh_getopt_copyright (const char * dummy)
 {
-  fprintf (stdout, 
+  fprintf (stdout, "%s",
 	   _("Copyright (C) 1999-2008 Rainer Wichmann"\
 	     " (http://la-samhna.de).\n\n"));
 
-  fprintf (stdout, 
+  fprintf (stdout, "%s",
 	   _("This program is free software; "\
 	     "you can redistribute it and/or modify\n"));
-  fprintf (stdout, _("it under the terms of the GNU General "\
+  fprintf (stdout, "%s",_("it under the terms of the GNU General "\
 		     "Public License as published by\n"));
-  fprintf (stdout, _("the Free Software Foundation; either version 2 "\
+  fprintf (stdout, "%s",_("the Free Software Foundation; either version 2 "\
 		     "of the License, or\n"));
-  fprintf (stdout, _("(at your option) any later version.\n\n"));
-
-  fprintf (stdout, _("This program is distributed in the hope "\
+  fprintf (stdout, "%s",_("(at your option) any later version.\n\n"));
+
+  fprintf (stdout, "%s",_("This program is distributed in the hope "\
 		     "that it will be useful,\n"));
-  fprintf (stdout, _("but WITHOUT ANY WARRANTY; "\
+  fprintf (stdout, "%s",_("but WITHOUT ANY WARRANTY; "\
 		     "without even the implied warranty of\n"));
-  fprintf (stdout, _("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."\
-		     " See the\n"));
-  fprintf (stdout, _("GNU General Public License for more details.\n\n"));
-
-  fprintf (stdout, _("You should have received a copy of the "\
+  fprintf (stdout, "%s",_("MERCHANTABILITY or FITNESS FOR A PARTICULAR "\
+		     "PURPOSE. See the\n"));
+  fprintf (stdout, "%s",_("GNU General Public License for more details.\n\n"));
+
+  fprintf (stdout, "%s",_("You should have received a copy of the "\
 		     "GNU General Public License\n"));
-  fprintf (stdout, _("along with this program; "\
+  fprintf (stdout, "%s",_("along with this program; "\
 		     "if not, write to the Free Software\n"));
-  fprintf (stdout, _("Foundation, Inc., 59 Temple Place - Suite 330, "\
+  fprintf (stdout, "%s",_("Foundation, Inc., 59 Temple Place - Suite 330, "\
 		     "Boston, MA  02111-1307, USA.\n\n"));
 
-  fprintf (stdout, _("This product makes use of the reference implementation "\
-		     "of the TIGER message\n"));
-  fprintf (stdout, _("digest algorithm. This code is copyright Eli Biham "\
+  fprintf (stdout, "%s",_("This product makes use of the reference "\
+		     "implementation of the TIGER message\n"));
+  fprintf (stdout, "%s",_("digest algorithm. This code is copyright Eli Biham "\
 		     "(biham@cs.technion.ac.il)\n"));
-  fprintf (stdout, _("and Ross Anderson (rja14@cl.cam.ac.uk). It can be used "\
+  fprintf (stdout, "%s",_("and Ross Anderson (rja14@cl.cam.ac.uk). It can be used "\
 		     "freely without any\n"));
-  fprintf (stdout, _("restrictions.\n"));
+  fprintf (stdout, "%s",_("restrictions.\n"));
 #if defined(USE_SRP_PROTOCOL) && !defined(SH_STANDALONE)
 #if (!defined(HAVE_LIBGMP) || !defined(HAVE_GMP_H))
-  fprintf (stdout, _("This product makes use of the 'bignum' library by "\
+  fprintf (stdout, "%s",_("This product makes use of the 'bignum' library by "\
 		     "Henrik Johansson\n"));
-  fprintf (stdout, _("(Henrik.Johansson@Nexus.Comm.SE). If you are including "\
-		     "this library in a\n"));
-  fprintf (stdout, _("commercial product, be sure to distribute ALL of"\
+  fprintf (stdout, "%s",_("(Henrik.Johansson@Nexus.Comm.SE). If you are "\
+		     "including this library in a\n"));
+  fprintf (stdout, "%s",_("commercial product, be sure to distribute ALL of"\
 		     " it with the product.\n"));
 #endif
-  fprintf (stdout, _("This product uses the 'Secure Remote Password' "\
+  fprintf (stdout, "%s",_("This product uses the 'Secure Remote Password' "\
 		     "cryptographic\n"));
-  fprintf (stdout, _("authentication system developed by Tom Wu "\
+  fprintf (stdout, "%s",_("authentication system developed by Tom Wu "\
 		     "(tjw@CS.Stanford.EDU).\n"));
 #endif
-  fprintf (stdout, _("\nPlease refer to the file COPYING in the source "\
+  fprintf (stdout, "%s",_("\nPlease refer to the file COPYING in the source "\
 		     "distribution for a"));
-  fprintf (stdout, _("\nfull list of incorporated code and associated "\
+  fprintf (stdout, "%s",_("\nfull list of incorporated code and associated "\
 		     "licenses.\n"));
 
@@ -644,8 +644,8 @@
 	     "(c) 1999-2006 Rainer Wichmann (http://la-samhna.de).\n"),
 	   VERSION);
-  fprintf (stdout, _("This software comes with ABSOLUTELY NO WARRANTY. "));
-  fprintf (stdout, _("Use at own risk.\n"));
-
-  fprintf (stdout, _("Usage:\n\n"));
+  fprintf (stdout, "%s",_("This software comes with ABSOLUTELY NO WARRANTY. "));
+  fprintf (stdout, "%s",_("Use at own risk.\n"));
+
+  fprintf (stdout, "%s",_("Usage:\n\n"));
 
   for (i = 0; op_table[i].longopt != NULL; ++i) {
@@ -656,5 +656,5 @@
     if (op_table[i].shortopt != '-' && 
 	strchr(opts, op_table[i].shortopt) != NULL)
-      fprintf (stdout, _("Short option char collision !\n"));
+      fprintf (stdout, "%s",_("Short option char collision !\n"));
     opts[i] = op_table[i].shortopt;
 
@@ -689,5 +689,5 @@
   }
 
-  fprintf (stdout, 
+  fprintf (stdout, "%s",
 	   _("\nPlease report bugs to support@la-samhna.de.\n"));
 
@@ -767,5 +767,5 @@
 			      /* not last option
 			       */
-			      fprintf (stderr, 
+			      fprintf (stderr, "%s",
 				       _("Error: short option with argument is not last in option string\n"));
 			      (void) sh_getopt_usage(_("fail"));
@@ -775,5 +775,6 @@
 			      /* argument required, but no avail 
 			       */
-			      fprintf (stderr, _("Error: missing argument\n"));
+			      fprintf (stderr, "%s",
+				       _("Error: missing argument\n"));
 			      (void) sh_getopt_usage(_("fail"));
 			    } 
@@ -813,5 +814,5 @@
 	    {
 	      /* unrecognized short option */
-	      fprintf (stderr, _("Error: unrecognized short option\n"));
+	      fprintf (stderr, "%s",_("Error: unrecognized short option\n"));
 	      (void) sh_getopt_usage(_("fail"));
 	    }
@@ -840,5 +841,6 @@
 			      /* argument required, but no avail 
 			       */
-			      fprintf (stderr, _("Error: missing argument\n"));
+			      fprintf (stderr, "%s",
+				       _("Error: missing argument\n"));
 			      (void) sh_getopt_usage(_("fail"));
 			    } 
@@ -870,5 +872,6 @@
 			  else 
 			    {
-			      fprintf (stderr, _("Error: invalid argument\n"));
+			      fprintf (stderr, "%s",
+				       _("Error: invalid argument\n"));
 			      /* argument required, but no avail */
 			      (void) sh_getopt_usage(_("fail"));
@@ -899,5 +902,5 @@
 	    {
 	      /* unrecognized long option */
-	      fprintf (stderr, _("Error: unrecognized long option\n"));
+	      fprintf (stderr, "%s",_("Error: unrecognized long option\n"));
 	      (void) sh_getopt_usage(_("fail"));
 	    }